function [ data_IQx data_IQy ]=CD_fil_fde ( datax , datay , fft_length , dispersion, wavelength , sample_period )
m = size ( datax , 1) ; 
if m == 1 
    datax = datax ( : ) ; 
    datay = datay ( : ) ; 
end
m = size (datax , 1) ;
if m == 1 
    datay = datay ( : ) ; 
end

ndata = size ( datax , 1 ) ;

if fft_length > 2^20
        err ( generatemsgid ( ' filterTooLong ' ) , ' Filters of length greater than 2^20 are not supported . Use dfilt .fftfir instead . ' ) ; 
end
if fft_length > ndata 
    err (generatemsgid ( 'filterTooShort ' ) , ' Filter length must be shorter than data length ' ) ;
else
%% L and G calculation

G = fft_length / 4 ; L =fft_length / 2 ; 
%% construction of the filter 
%here the filter is constructed using the frequency domain formula directly 
%from the theory

C = 3e5 ; %speed of light in km/s 
q=(-fft_length / 2 : fft_length /2 - 1)' ; 
omega=2*pi*(q) /( sample_period * fft_length ) ; 
filt=exp(-1i*(dispersion*(wavelength) ^2/(4 *pi *C) ) *omega .^ 2 ) ;

%fil is a structure where are saved all the parameters needed for perform the o v e r la p method 
fil = struct ( 'filter' , filt , 'nfft' , fft_length , 'window' , L, 'ndata' , ndata ,'overlap' , G) ;

%main program 
data_IQx = overlap_add ( fil , datax ) ; 
data_IQy = overlap_add ( fil , datay ) ; 
end
end