% close all; 
% format short;

OutputPort1 = InputPort1; 
OutputPort2 = InputPort2; 
OutputPort3 = InputPort3; 
OutputPort4 = InputPort4;

%%%%%%%%%%%%%%%%%%%%%%% Parameters Definition %%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
ChannelWavelength = ChannelWavelength * 1e-9; 
DispersionRefWavelength = DispersionRefWavelength * 1e-9; 
ResidualDispersion = ResidualDispersion * 1e-12 / 1e-6; %Dispersion 
ResidualDispersionSlope = ResidualDispersionSlope * 1e-12 / 1e-15; %Dispersion slope
c0 = 2.99792458e8;
fft_length=128;

%%%%%%%%%%%%%%%%%%%%%%%%% Down Sampling %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% SamplesPerSymbolIn = length(InputPort1.Sampled.Signal) / NumberOfSymbols; % calculates number of samples per symbol

% InX_Signal = ones(1, NumberOfSymbols * SamplesPerSymbol); 
% InX_Noise = ones(1, NumberOfSymbols * SamplesPerSymbol); 
% InY_Signal = ones(1, NumberOfSymbols * SamplesPerSymbol); 
% InY_Noise = ones(1, NumberOfSymbols * SamplesPerSymbol);
% 
% for m = 1 : NumberOfSymbols * SamplesPerSymbol
%     InX_Signal(1,m) =   InputPort1.Sampled.Signal((2*m-1) * SamplesPerSymbolIn / (2*SamplesPerSymbol)) + 1i * InputPort2.Sampled.Signal((2*m-1) * SamplesPerSymbolIn / (2*SamplesPerSymbol));
%     InX_Noise(1,m)  =   InputPort1.Noise.Signal((2*m-1) * SamplesPerSymbolIn / (2*SamplesPerSymbol)) + 1i * InputPort2.Noise.Signal((2*m-1) * SamplesPerSymbolIn / (2*SamplesPerSymbol));
%     InX             =   InX_Signal + InX_Noise;
%     InY_Signal(1,m) =   InputPort3.Sampled.Signal((2*m-1)*SamplesPerSymbolIn/(2*SamplesPerSymbol))+1i*InputPort4.Sampled.Signal((2*m-1)*SamplesPerSymbolIn/(2*SamplesPerSymbol));
%     InY_Noise(1,m)  =   InputPort3.Noise.Signal((2*m-1)*SamplesPerSymbolIn/(2*SamplesPerSymbol))+1i*InputPort4.Noise.Signal((2*m-1)*SamplesPerSymbolIn/(2*SamplesPerSymbol));
%     InY             =   InY_Signal + InY_Noise;
% end;
% clear InX_Signal; 
% clear InX_Noise; 
% clear InY_Signal; 
% clear InY_Noise;
%%%%%% downsampling
yrxI = real(InputPort1.Sampled.Signal)+real(InputPort1.Noise.Signal);
yrxQ = real(InputPort2.Sampled.Signal)+real(InputPort2.Noise.Signal);

RyI = real(InputPort3.Sampled.Signal)+real(InputPort3.Noise.Signal);
RyQ = real(InputPort4.Sampled.Signal)+real(InputPort4.Noise.Signal);
NumberOfSymbols=NumberOfSymbols;
SamplesPerSymbol=SamplesPerSymbol;


InX=(reshape(yrxI,SamplesPerSymbol,NumberOfSymbols))+1i*(reshape(yrxQ,SamplesPerSymbol,NumberOfSymbols));
InY=(reshape(RyI,SamplesPerSymbol,NumberOfSymbols))+1i*(reshape(RyQ,SamplesPerSymbol,NumberOfSymbols));
InX = InX(SamplesPerSymbol/2,:);
InY = InY(SamplesPerSymbol/2,:);
%%%%%% end 

%In_X: signal and noise for polarization X 
%In_Y: signal and noise for polarization Y

% SampledVector = (2*(1:NumberOfSymbols*SamplesPerSymbol)-1)*SamplesPerSymbolIn/(2*SamplesPerSymbol); 
% TimeSampledVector = InputPort1.Sampled.Time(SampledVector);

%%%%%%%%%%%%%% Normalizing %%%%%%%%%%%%%%%%%%%%%% 
OutX = InX/sqrt(mean(abs(InX).^2)); 
OutY = InY/sqrt(mean(abs(InY).^2));

StoreInX = OutX; 
StoreInY = OutY;

% clear SampledVector; 
%%%%%%%%%%%%%%%%%%%%%% Dispersion Compensation in Frequency domain %%%%%%%%%%%%%%%
EnableD=1;
if EnableD == 1 
    data_IQx=OutX; 
    data_IQy=OutY; 
    %sample_period=1e12/(SymbolRate*NewSamplesPerSymbol);
    %recovering sampling period in 'ps' 
    SymbolRate=100e9;
    PropagationLength=10e3;
    sample_period=1e12/(SymbolRate*SamplesPerSymbol); 
    Dispersion=ResidualDispersion*PropagationLength;
    %CD_fil_fde generates the filter and perform the filtering in the 
    %frequency domain 
    [data_IQx data_IQy]=CD_fil_fde (data_IQx, data_IQy, fft_length, Dispersion, DispersionRefWavelength*1e9, sample_period);
   %%Nonlinear compensator 
   NLC = 0; 
   if NLC == 1
        alpha= 25; 
        beta = 25;
        %they need to be optimized
        data_IQx = data_IQx.*exp(-1i*(alpha*(abs(data_IQx)).^2+beta*(abs(data_IQy)).^2));
        data_IQy = data_IQy.*exp(-1i*(alpha*(abs(data_IQy)).^2+beta*(abs(data_IQx)).^2));
    end
end
OutX = data_IQx.'; 
OutY = data_IQy.'; 
AfterDX = OutX;
AfterDY = OutY;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Interpolation and Output to OptiSystem %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% OutputPort1.Sampled.Signal = interp1(TimeSampledVector,real(OutX),InputPort1.Sampled.Time,InterpolationMethod); 
% OutputPort2.Sampled.Signal = interp1(TimeSampledVector,imag(OutX),InputPort1.Sampled.Time,InterpolationMethod); 
% OutputPort3.Sampled.Signal = interp1(TimeSampledVector,real(OutY),InputPort1.Sampled.Time,InterpolationMethod); 
% OutputPort4.Sampled.Signal = interp1(TimeSampledVector,imag(OutY),InputPort1.Sampled.Time,InterpolationMethod);
OutputPort1.Sampled.Signal = interp(real(OutX),SamplesPerSymbol); 
OutputPort2.Sampled.Signal = interp1(imag(OutX),SamplesPerSymbol); 
OutputPort3.Sampled.Signal = interp1(real(OutY),SamplesPerSymbol); 
OutputPort4.Sampled.Signal = interp1(imag(OutY),SamplesPerSymbol);

